<template>
    <div v-if="unpaidList.length"
         class="schedule-list-container"
         :class="{expanded: expanded}">
        <div class="graph-blocks" v-if="mounted">
            <div class="schedule-list">
                <div class="schedule"
                     v-for="(schedule, index) in unpaidList"
                     :key="schedule.date"
                     :class="{expanded: expanded}"
                     :style="style(index)">
                        <div class="sum">{{schedule.amount|currency}} ₽</div>
                        <div class="date">до {{schedule.date|date}}</div>
                </div>
            </div>
        </div>

        <div class="expand" @click="expanded = !expanded" :class="{expanded: expanded}">
            <SVGIcon xlink="collapse-20" :rotate="expanded ? 180 : 0" view-box="0 0 20 20"></SVGIcon>
        </div>
    </div>
</template>

<script>
    import dayjs from 'dayjs';
    import {ruMonthName} from '@/helpers';
    import SVGIcon from '@/components/SVGIcon';

	export default {
        name: 'component-pos-schedule-list',
        components: {
        	SVGIcon
        },
        props: {
			/**
             * @type [iPosSchedule]
			 */
			list: {
				required: true,
                type: Array,
            }
        },

        data () {
        	return {
        		expanded: false,
				mounted: false,
            }
        },

        computed: {
        	unpaidList () {
        		return this.list.filter((schedule) => {
        			return schedule.isPaid === false && schedule.isOverdue === false;
                }).slice(1);
            }
        },

		filters: {
			date(value) {
				const date = dayjs(value);
				return date.format('DD') + ' ' + ruMonthName(date.format('MM')) + ' ' + date.format('YYYY');
			}
		},

        mounted () {
        	this.mounted = true;
        },

        methods: {
        	style (index) {

        		if(this.expanded) {
        			return {};
                }

                const style =  {
        			width: `calc(100% - ${index * 5 * 2 + 5}px)`,
                    left: `${index * 5 + 5}px`,
                    top:  index * 5 + 5 -66 + 'px',
                    'z-index': (-1) * index - 1,
                };
                return style;
            }
        }
	};
</script>

<style scoped>

</style>
